<a id="mypy-boto3-greengrassv2"></a>

# mypy-boto3-greengrassv2

[![PyPI - types-aiobotocore-greengrassv2](https://img.shields.io/pypi/v/types-aiobotocore-greengrassv2.svg?color=blue)](https://pypi.org/project/types-aiobotocore-greengrassv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-greengrassv2.svg?color=blue)](https://pypi.org/project/types-aiobotocore-greengrassv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-greengrassv2?color=blue)](https://pypistats.org/packages/types-aiobotocore-greengrassv2)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.GreengrassV2 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/greengrassv2.html#GreengrassV2)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-greengrassv2 docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_greengrassv2/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-greengrassv2](#mypy-boto3-greengrassv2)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `GreengrassV2`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `GreengrassV2` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[greengrassv2]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[greengrassv2]'

# standalone installation
python -m pip install types-aiobotocore-greengrassv2
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[greengrassv2]` in your environment:
  `python -m pip install 'types-aiobotocore[greengrassv2]'`

Both type checking and auto-complete should work for `GreengrassV2` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[greengrassv2]` in your environment:
  `python -m pip install 'types-aiobotocore[greengrassv2]'`

Both type checking and auto-complete should work for `GreengrassV2` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[greengrassv2]` in your environment:
  `python -m pip install 'types-aiobotocore[greengrassv2]'`
- Run `mypy` as usual

Type checking should work for `GreengrassV2` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[greengrassv2]` in your environment:
  `python -m pip install 'types-aiobotocore[greengrassv2]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `GreengrassV2` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`GreengrassV2Client` provides annotations for
`session.create_client("greengrassv2")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_greengrassv2 import GreengrassV2Client

session = get_session()
async with session.create_client("greengrassv2") as client:
    client: GreengrassV2Client
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_greengrassv2.paginator` module contains type annotations for
all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_greengrassv2 import GreengrassV2Client
from types_aiobotocore_greengrassv2.paginator import (
    ListClientDevicesAssociatedWithCoreDevicePaginator,
    ListComponentVersionsPaginator,
    ListComponentsPaginator,
    ListCoreDevicesPaginator,
    ListDeploymentsPaginator,
    ListEffectiveDeploymentsPaginator,
    ListInstalledComponentsPaginator,
)

session = get_session()
async with session.create_client("greengrassv2") as client:
    client: GreengrassV2Client

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_client_devices_associated_with_core_device_paginator: ListClientDevicesAssociatedWithCoreDevicePaginator = client.get_paginator("list_client_devices_associated_with_core_device")
        list_component_versions_paginator: ListComponentVersionsPaginator = client.get_paginator("list_component_versions")
        list_components_paginator: ListComponentsPaginator = client.get_paginator("list_components")
        list_core_devices_paginator: ListCoreDevicesPaginator = client.get_paginator("list_core_devices")
        list_deployments_paginator: ListDeploymentsPaginator = client.get_paginator("list_deployments")
        list_effective_deployments_paginator: ListEffectiveDeploymentsPaginator = client.get_paginator("list_effective_deployments")
        list_installed_components_paginator: ListInstalledComponentsPaginator = client.get_paginator("list_installed_components")
    ```







### Literals

`types_aiobotocore_greengrassv2.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_greengrassv2.literals import (
    CloudComponentStateType,
    ComponentDependencyTypeType,
    ComponentVisibilityScopeType,
    CoreDeviceStatusType,
    DeploymentComponentUpdatePolicyActionType,
    DeploymentFailureHandlingPolicyType,
    DeploymentHistoryFilterType,
    DeploymentStatusType,
    EffectiveDeploymentExecutionStatusType,
    InstalledComponentLifecycleStateType,
    IoTJobAbortActionType,
    IoTJobExecutionFailureTypeType,
    LambdaEventSourceTypeType,
    LambdaFilesystemPermissionType,
    LambdaInputPayloadEncodingTypeType,
    LambdaIsolationModeType,
    ListClientDevicesAssociatedWithCoreDevicePaginatorName,
    ListComponentVersionsPaginatorName,
    ListComponentsPaginatorName,
    ListCoreDevicesPaginatorName,
    ListDeploymentsPaginatorName,
    ListEffectiveDeploymentsPaginatorName,
    ListInstalledComponentsPaginatorName,
    RecipeOutputFormatType,
    ServiceName,
    PaginatorName,
)

def check_value(value: CloudComponentStateType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_greengrassv2.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_greengrassv2.type_defs import (
    AssociateClientDeviceWithCoreDeviceEntryTypeDef,
    AssociateClientDeviceWithCoreDeviceErrorEntryTypeDef,
    AssociatedClientDeviceTypeDef,
    BatchAssociateClientDeviceWithCoreDeviceRequestRequestTypeDef,
    BatchAssociateClientDeviceWithCoreDeviceResponseTypeDef,
    BatchDisassociateClientDeviceFromCoreDeviceRequestRequestTypeDef,
    BatchDisassociateClientDeviceFromCoreDeviceResponseTypeDef,
    CancelDeploymentRequestRequestTypeDef,
    CancelDeploymentResponseTypeDef,
    CloudComponentStatusTypeDef,
    ComponentCandidateTypeDef,
    ComponentConfigurationUpdateTypeDef,
    ComponentDependencyRequirementTypeDef,
    ComponentDeploymentSpecificationTypeDef,
    ComponentLatestVersionTypeDef,
    ComponentPlatformTypeDef,
    ComponentRunWithTypeDef,
    ComponentTypeDef,
    ComponentVersionListItemTypeDef,
    CoreDeviceTypeDef,
    CreateComponentVersionRequestRequestTypeDef,
    CreateComponentVersionResponseTypeDef,
    CreateDeploymentRequestRequestTypeDef,
    CreateDeploymentResponseTypeDef,
    DeleteComponentRequestRequestTypeDef,
    DeleteCoreDeviceRequestRequestTypeDef,
    DeploymentComponentUpdatePolicyTypeDef,
    DeploymentConfigurationValidationPolicyTypeDef,
    DeploymentIoTJobConfigurationTypeDef,
    DeploymentPoliciesTypeDef,
    DeploymentTypeDef,
    DescribeComponentRequestRequestTypeDef,
    DescribeComponentResponseTypeDef,
    DisassociateClientDeviceFromCoreDeviceEntryTypeDef,
    DisassociateClientDeviceFromCoreDeviceErrorEntryTypeDef,
    EffectiveDeploymentTypeDef,
    GetComponentRequestRequestTypeDef,
    GetComponentResponseTypeDef,
    GetComponentVersionArtifactRequestRequestTypeDef,
    GetComponentVersionArtifactResponseTypeDef,
    GetCoreDeviceRequestRequestTypeDef,
    GetCoreDeviceResponseTypeDef,
    GetDeploymentRequestRequestTypeDef,
    GetDeploymentResponseTypeDef,
    InstalledComponentTypeDef,
    IoTJobAbortConfigTypeDef,
    IoTJobAbortCriteriaTypeDef,
    IoTJobExecutionsRolloutConfigTypeDef,
    IoTJobExponentialRolloutRateTypeDef,
    IoTJobRateIncreaseCriteriaTypeDef,
    IoTJobTimeoutConfigTypeDef,
    LambdaContainerParamsTypeDef,
    LambdaDeviceMountTypeDef,
    LambdaEventSourceTypeDef,
    LambdaExecutionParametersTypeDef,
    LambdaFunctionRecipeSourceTypeDef,
    LambdaLinuxProcessParamsTypeDef,
    LambdaVolumeMountTypeDef,
    ListClientDevicesAssociatedWithCoreDeviceRequestRequestTypeDef,
    ListClientDevicesAssociatedWithCoreDeviceResponseTypeDef,
    ListComponentVersionsRequestRequestTypeDef,
    ListComponentVersionsResponseTypeDef,
    ListComponentsRequestRequestTypeDef,
    ListComponentsResponseTypeDef,
    ListCoreDevicesRequestRequestTypeDef,
    ListCoreDevicesResponseTypeDef,
    ListDeploymentsRequestRequestTypeDef,
    ListDeploymentsResponseTypeDef,
    ListEffectiveDeploymentsRequestRequestTypeDef,
    ListEffectiveDeploymentsResponseTypeDef,
    ListInstalledComponentsRequestRequestTypeDef,
    ListInstalledComponentsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    PaginatorConfigTypeDef,
    ResolveComponentCandidatesRequestRequestTypeDef,
    ResolveComponentCandidatesResponseTypeDef,
    ResolvedComponentVersionTypeDef,
    ResponseMetadataTypeDef,
    SystemResourceLimitsTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
)

def get_structure() -> AssociateClientDeviceWithCoreDeviceEntryTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-greengrassv2` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-greengrassv2 docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_greengrassv2/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
